VERSION 5.00
Begin VB.UserControl ComputerFunctions 
   ClientHeight    =   495
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   InvisibleAtRuntime=   -1  'True
   ScaleHeight     =   495
   ScaleWidth      =   4800
   ToolboxBitmap   =   "ComputerFunctions.ctx":0000
   Begin VB.Label lblTitle 
      Caption         =   "Computer Functions"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      Height          =   390
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   3165
   End
End
Attribute VB_Name = "ComputerFunctions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'///////////////////////////////////////////
'// Computer Functions doesn't have an interface
'// In reality it just acts as a class module

' Constants
    Private Const MAX_PATH = 260
    
    Private Const CSIDL_FLAG_CREATE = &H8000&          'combine with CSIDL_ value to force
                                                       'create on SHGetSpecialFolderLocation()
    Private Const CSIDL_FLAG_DONT_VERIFY = &H4000       'combine with CSIDL_ value to force
                                                        'create on SHGetSpecialFolderLocation()
    Private Const CSIDL_FLAG_MASK = &HFF00             'mask for all possible flag values
    Private Const SHGFP_TYPE_CURRENT = &H0             'current value for user, verify it exists
    Private Const SHGFP_TYPE_DEFAULT = &H1
    
    
    Private Const MAX_CNLENGTH = 32
    Private Const MAX_STDLENGTH = 256

' For Users profile
    Private Const TOKEN_QUERY = (&H8)
    
' Error Constants
    Private Const ERROR_NOTNT = 256

'Types
    Public Type tUserNameEx
        NameUnknown As String
        NameFullyQualifiedDN As String
        NameSamCompatible As String
        NameDisplay As String
        NameUniqueId As String
        NameCanonical As String
        NameUserPrincipal As String
        NameCanonicalEx As String
        NameServicePrincipal As String
        Errors As Long
    End Type

' For GetComputerNameEX (NT ONLY)
    Public Type tComputerNameEx
        NetBIOS As String
        DNSHostName As String
        DNSDomain As String
        DNSFullyQualified As String
        PhysicalNetBIOS As String
        PhysicalDNSHostName As String
        PhysicalDNSDomain As String
        PhysicalDNSFullyQualified As String
        Errors As Long
    End Type

' For OS Version return
    Public Type tOSVersionInfo
        dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformId As Long
        szCSDVersion As String
        Errors As Boolean
    End Type
' For osversion API
    Private Type OSVERSIONINFO
        dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformId As Long
        szCSDVersion As String * 128
    End Type

' Enums
' For GetComputerNameEX (NT ONLY)
    Private Enum COMPUTER_NAME_FORMAT
        ComputerNameNetBIOS
        ComputerNameDnsHostname
        ComputerNameDnsDomain
        ComputerNameDnsFullyQualified
        ComputerNamePhysicalNetBIOS
        ComputerNamePhysicalDnsHostname
        ComputerNamePhysicalDnsDomain
        ComputerNamePhysicalDnsFullyQualified
        computerNameMax
    End Enum

    Private Enum EXTENDED_NAME_FORMAT
        NameUnknown = 0
        NameFullyQualifiedDN = 1
        NameSamCompatible = 2
        NameDisplay = 3
        NameUniqueId = 6
        NameCanonical = 7
        NameUserPrincipal = 8
        NameCanonicalEx = 9
        NameServicePrincipal = 10
    End Enum

    Public Enum eSpecialFolders
        CSIDL_DESKTOP = &H0                 '{desktop}
        CSIDL_INTERNET = &H1                'Internet Explorer (icon on desktop)
        CSIDL_PROGRAMS = &H2                'Start Menu\Programs
        CSIDL_CONTROLS = &H3                'My Computer\Control Panel
        CSIDL_PRINTERS = &H4                'My Computer\Printers
        CSIDL_PERSONAL = &H5                'My Documents
        CSIDL_FAVORITES = &H6               '{user}\Favourites
        CSIDL_STARTUP = &H7                 'Start Menu\Programs\Startup
        CSIDL_RECENT = &H8                  '{user}\Recent
        CSIDL_SENDTO = &H9                  '{user}\SendTo
        CSIDL_BITBUCKET = &HA               '{desktop}\Recycle Bin
        CSIDL_STARTMENU = &HB               '{user}\Start Menu
        CSIDL_DESKTOPDIRECTORY = &H10       '{user}\Desktop
        CSIDL_DRIVES = &H11                 'My Computer
        CSIDL_NETWORK = &H12                'Network Neighbourhood
        CSIDL_NETHOOD = &H13                '{user}\nethood
        CSIDL_FONTS = &H14                  'windows\fonts
        CSIDL_TEMPLATES = &H15
        CSIDL_COMMON_STARTMENU = &H16       'All Users\Start Menu
        CSIDL_COMMON_PROGRAMS = &H17        'All Users\Programs
        CSIDL_COMMON_STARTUP = &H18         'All Users\Startup
        CSIDL_COMMON_DESKTOPDIRECTORY = &H19 'All Users\Desktop
        CSIDL_APPDATA = &H1A                '{user}\Application Data
        CSIDL_PRINTHOOD = &H1B              '{user}\PrintHood
        CSIDL_LOCAL_APPDATA = &H1C          '{user}\Local Settings\Application Data (non roaming)
        CSIDL_ALTSTARTUP = &H1D             'non localized startup
        CSIDL_COMMON_ALTSTARTUP = &H1E      'non localized common startup
        CSIDL_COMMON_FAVORITES = &H1F
        CSIDL_INTERNET_CACHE = &H20
        CSIDL_COOKIES = &H21
        CSIDL_HISTORY = &H22
        CSIDL_COMMON_APPDATA = &H23          'All Users\Application Data
        CSIDL_WINDOWS = &H24                 'GetWindowsDirectory()
        CSIDL_SYSTEM = &H25                  'GetSystemDirectory()
        CSIDL_PROGRAM_FILES = &H26           'C:\Program Files
        CSIDL_MYPICTURES = &H27              'C:\Program Files\My Pictures
        CSIDL_PROFILE = &H28                 'USERPROFILE
        CSIDL_SYSTEMX86 = &H29               'x86 system directory on RISC
        CSIDL_PROGRAM_FILESX86 = &H2A        'x86 C:\Program Files on RISC
        CSIDL_PROGRAM_FILES_COMMON = &H2B    'C:\Program Files\Common
        CSIDL_PROGRAM_FILES_COMMONX86 = &H2C 'x86 Program Files\Common on RISC
        CSIDL_COMMON_TEMPLATES = &H2D        'All Users\Templates
        CSIDL_COMMON_DOCUMENTS = &H2E        'All Users\Documents
        CSIDL_COMMON_ADMINTOOLS = &H2F       'All Users\Start Menu\Programs\Administrative Tools
        CSIDL_ADMINTOOLS = &H30              '{user}\Start Menu\Programs\Administrative Tools
    End Enum

' APIs
    Private Declare Function GetComputerName Lib "kernel32" Alias "GetComputerNameA" (ByVal lpBuffer As String, nSize As Long) As Long
    Private Declare Function GetComputerNameEx Lib "kernel32.dll" Alias "GetComputerNameExA" (ByVal NameType As COMPUTER_NAME_FORMAT, ByVal lpBuffer As String, ByRef nSize As Long) As Long
    
    Private Declare Function GetUserName Lib "advapi32.dll" Alias "GetUserNameA" (ByVal lpBuffer As String, nSize As Long) As Long
    Private Declare Function GetUserNameEx Lib "secur32.dll" Alias "GetUserNameExA" (ByVal NameFormat As EXTENDED_NAME_FORMAT, ByVal lpNameBuffer As String, ByRef nSize As Long) As Long

    Private Declare Function GetAllUsersProfileDirectory Lib "userenv.dll" Alias "GetAllUsersProfileDirectoryA" (ByVal lpProfileDir As String, lpcchSize As Long) As Boolean
    Private Declare Function GetDefaultUserProfileDirectory Lib "userenv.dll" Alias "GetDefaultUserProfileDirectoryA" (ByVal lpProfileDir As String, lpcchSize As Long) As Boolean
    Private Declare Function GetProfilesDirectory Lib "userenv.dll" Alias "GetProfilesDirectoryA" (ByVal lpProfileDir As String, lpcchSize As Long) As Boolean
    Private Declare Function GetUserProfileDirectory Lib "userenv.dll" Alias "GetUserProfileDirectoryA" (ByVal hToken As Long, ByVal lpProfileDir As String, lpcchSize As Long) As Boolean
    Private Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
    
    Private Declare Function GetCurrentProcess Lib "kernel32" () As Long
    Private Declare Function OpenProcessToken Lib "advapi32" (ByVal ProcessHandle As Long, ByVal DesiredAccess As Long, TokenHandle As Long) As Long

    Private Declare Function SHGetPathFromIDList Lib "shell32" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
    Private Declare Function SHGetSpecialFolderLocation Lib "shell32" (ByVal hwndOwner As Long, ByVal nFolder As Long, pidl As Long) As Long
    Private Declare Sub CoTaskMemFree Lib "ole32" (ByVal pv As Long)

' To Kill any non-NT specific functions
    Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long

' Local Vars
    Dim l_IsWinNT As Boolean

Option Explicit

Public Function GetSpecialFolder(ByVal Folder As eSpecialFolders, ByVal hWnd As Long) As String
    Dim sPath As String
    Dim pidl As Long
   
    'fill the idl structure with the specified folder item
    If SHGetSpecialFolderLocation(hWnd, Folder, pidl) = 0 Then
    ' If everything's allright, get the path
        sPath = Space$(MAX_PATH)
        If SHGetPathFromIDList(ByVal pidl, ByVal sPath) Then
            GetSpecialFolder = StripEndNull(sPath)
        End If
        
    ' Free pidl
        CoTaskMemFree pidl
    Else
        GetSpecialFolder = ""
    End If
End Function

Public Function SystemDirectory() As String
    Dim sBuffer As String
    Dim lRet As Long
    Dim lSize As Long
    
    sBuffer = String(MAX_STDLENGTH, Chr(0))
    lSize = Len(sBuffer)
    
    lRet = GetSystemDirectory(sBuffer, lSize)
    If lRet > 0 Then
        SystemDirectory = Left(sBuffer, lRet)
    Else
        SystemDirectory = ""
    End If
End Function

Public Function ProfilesDirectory() As String
    Dim sBuffer As String
    Dim fRet As Boolean
    Dim lSize As Long
    
    If l_IsWinNT Then
        sBuffer = String(MAX_STDLENGTH, Chr(0))
        lSize = Len(sBuffer)
        
        fRet = GetProfilesDirectory(sBuffer, lSize)
        If fRet Then
            ProfilesDirectory = StripEndNull(sBuffer)
        Else
            ProfilesDirectory = ""
        End If
    Else
        ProfilesDirectory = ""
    End If
End Function

Public Function UserProfileDirectory() As String
    Dim sBuffer As String
    Dim fRet As Boolean
    Dim lSize As Long
    Dim lToken As Long
    
    If l_IsWinNT Then
        sBuffer = String(MAX_STDLENGTH, Chr(0))
        lSize = Len(sBuffer)
        
        OpenProcessToken GetCurrentProcess, TOKEN_QUERY, lToken
        
        fRet = GetUserProfileDirectory(lToken, sBuffer, lSize)
    
        If fRet Then
            UserProfileDirectory = StripEndNull(sBuffer)
        Else
            UserProfileDirectory = ""
        End If
    Else
        UserProfileDirectory = ""
    End If
End Function

Public Function AllUsersProfileFolder() As String
    Dim sBuffer As String
    Dim fRet As Boolean
    Dim lSize As Long
    
    If l_IsWinNT Then
        sBuffer = String(MAX_STDLENGTH, Chr(0))
        lSize = Len(sBuffer)
        
        fRet = GetAllUsersProfileDirectory(sBuffer, lSize)
        
        If fRet Then
            AllUsersProfileFolder = StripEndNull(sBuffer)
        Else
            AllUsersProfileFolder = ""
        End If
    End If
End Function

Public Function IsWinNT() As Boolean
    Dim OSInfo As tOSVersionInfo
    
    OSInfo = OSVersion
    
    IsWinNT = Not OSInfo.Errors And OSInfo.dwPlatformId >= 2
End Function

Public Function OSVersion() As tOSVersionInfo
' dwPlatformId:
' 0-Windows 32s, 1-9x, 2-NT
    Dim OSInfo As OSVERSIONINFO
    Dim lRet As Long
    
    OSInfo.dwOSVersionInfoSize = Len(OSInfo)
    
    lRet = GetVersionEx(OSInfo)
        
    If lRet > 0 Then
        OSVersion.dwBuildNumber = OSInfo.dwBuildNumber
        OSVersion.dwMajorVersion = OSInfo.dwMajorVersion
        OSVersion.dwMinorVersion = OSInfo.dwMinorVersion
        OSVersion.dwOSVersionInfoSize = OSInfo.dwOSVersionInfoSize
        OSVersion.dwPlatformId = OSInfo.dwPlatformId
        OSVersion.szCSDVersion = OSInfo.szCSDVersion
        OSVersion.Errors = False
    Else
        OSVersion.Errors = True
    End If
End Function

Public Function UserName() As String
    Dim sBuffer As String
    Dim lRet As Long
    
    sBuffer = String(MAX_STDLENGTH, Chr(0))
    
    lRet = GetUserName(sBuffer, MAX_STDLENGTH)
    
    If lRet > 0 Then
        UserName = StripEndNull(sBuffer)
    Else
        UserName = ""
    End If
End Function

Public Function UserNameEx() As tUserNameEx
    Dim sBuffer As String
    Dim lSize As Long
    Dim lRet As Long
    
    If l_IsWinNT Then
    ' Init vars
        sBuffer = String(MAX_STDLENGTH, Chr(0))
        lSize = Len(sBuffer)
    
        lRet = GetUserNameEx(NameCanonical, sBuffer, lSize)
        If lRet > 0 Then
            UserNameEx.NameCanonical = StripEndNull(sBuffer)
        End If
    
        sBuffer = String(MAX_STDLENGTH, Chr(0))
        lRet = GetUserNameEx(NameCanonicalEx, sBuffer, lSize)
        If lRet > 0 Then
            UserNameEx.NameCanonicalEx = StripEndNull(sBuffer)
        End If
    
    
        sBuffer = String(MAX_STDLENGTH, Chr(0))
        lRet = GetUserNameEx(NameDisplay, sBuffer, lSize)
        If lRet > 0 Then
            UserNameEx.NameDisplay = StripEndNull(sBuffer)
        End If
    
    
        sBuffer = String(MAX_STDLENGTH, Chr(0))
        lRet = GetUserNameEx(NameFullyQualifiedDN, sBuffer, lSize)
        If lRet > 0 Then
            UserNameEx.NameFullyQualifiedDN = StripEndNull(sBuffer)
        End If
    
    
        sBuffer = String(MAX_STDLENGTH, Chr(0))
        lRet = GetUserNameEx(NameSamCompatible, sBuffer, lSize)
        If lRet > 0 Then
            UserNameEx.NameSamCompatible = StripEndNull(sBuffer)
        End If
    
    
        sBuffer = String(MAX_STDLENGTH, Chr(0))
        lRet = GetUserNameEx(NameServicePrincipal, sBuffer, lSize)
        If lRet > 0 Then
            UserNameEx.NameServicePrincipal = StripEndNull(sBuffer)
        End If
    
    
        sBuffer = String(MAX_STDLENGTH, Chr(0))
        lRet = GetUserNameEx(NameUniqueId, sBuffer, lSize)
        If lRet > 0 Then
            UserNameEx.NameUniqueId = StripEndNull(sBuffer)
        End If
    
    
        sBuffer = String(MAX_STDLENGTH, Chr(0))
        lRet = GetUserNameEx(NameUserPrincipal, sBuffer, lSize)
        If lRet > 0 Then
            UserNameEx.NameUserPrincipal = StripEndNull(sBuffer)
        End If
    
    
        sBuffer = String(MAX_STDLENGTH, Chr(0))
        lRet = GetUserNameEx(NameUnknown, sBuffer, lSize)
        If lRet > 0 Then
            UserNameEx.NameUnknown = StripEndNull(sBuffer)
        End If
    Else
        UserNameEx.Errors = ERROR_NOTNT
    End If
End Function

Public Function ComputerName() As String
    Dim sBuffer As String
    Dim lRet As Long

    sBuffer = String(MAX_CNLENGTH, Chr(0))
    
    lRet = GetComputerName(sBuffer, MAX_CNLENGTH)
    
    If lRet > 0 Then
        ComputerName = StripEndNull(sBuffer)
    Else
        ComputerName = ""
    End If
End Function

Public Function ComputerNameEx() As tComputerNameEx
' OK, this actually returns a LOT
    Dim sBuffer As String
    Dim lRet As Long
    Dim lSize As Long

' OK, since this is NT ONLY...
    If l_IsWinNT Then
    ' Init Vars
        sBuffer = String(MAX_STDLENGTH, Chr(0))
        lSize = Len(sBuffer)
    ' Get First Attrib
        lRet = GetComputerNameEx(ComputerNameDnsDomain, sBuffer, lSize)
        If lRet > 0 Then
            ComputerNameEx.DNSDomain = StripEndNull(sBuffer)
        End If
        
    ' OK, now we have to re-set the buffer, and get the next, etc
        sBuffer = String(MAX_STDLENGTH, Chr(0))
        
        lRet = GetComputerNameEx(ComputerNameDnsFullyQualified, sBuffer, lSize)
        If lRet > 0 Then
            ComputerNameEx.DNSFullyQualified = StripEndNull(sBuffer)
        End If
    
    ' Next Set
        sBuffer = String(MAX_STDLENGTH, Chr(0))
        
        lRet = GetComputerNameEx(ComputerNameDnsHostname, sBuffer, lSize)
        If lRet > 0 Then
            ComputerNameEx.DNSHostName = StripEndNull(sBuffer)
        End If
    
    ' Next Set
        sBuffer = String(MAX_STDLENGTH, Chr(0))
        
        lRet = GetComputerNameEx(ComputerNameNetBIOS, sBuffer, lSize)
        If lRet > 0 Then
            ComputerNameEx.NetBIOS = StripEndNull(sBuffer)
        End If
        
    ' Next Set
        sBuffer = String(MAX_STDLENGTH, Chr(0))
        
        lRet = GetComputerNameEx(ComputerNamePhysicalDnsDomain, sBuffer, lSize)
        If lRet > 0 Then
            ComputerNameEx.PhysicalDNSDomain = StripEndNull(sBuffer)
        End If
        
    ' Next Set
        sBuffer = String(MAX_STDLENGTH, Chr(0))
        
        lRet = GetComputerNameEx(ComputerNamePhysicalDnsFullyQualified, sBuffer, lSize)
        If lRet > 0 Then
            ComputerNameEx.PhysicalDNSFullyQualified = StripEndNull(sBuffer)
        End If
        
    ' Next Set
        sBuffer = String(MAX_STDLENGTH, Chr(0))
        
        lRet = GetComputerNameEx(ComputerNamePhysicalDnsHostname, sBuffer, lSize)
        If lRet > 0 Then
            ComputerNameEx.PhysicalDNSHostName = StripEndNull(sBuffer)
        End If
        
    ' Next Set
        sBuffer = String(MAX_STDLENGTH, Chr(0))
        
        lRet = GetComputerNameEx(ComputerNamePhysicalNetBIOS, sBuffer, lSize)
        If lRet > 0 Then
            ComputerNameEx.PhysicalNetBIOS = StripEndNull(sBuffer)
        End If
    Else
        ComputerNameEx.Errors = ERROR_NOTNT
    End If
End Function

'///////////////////
'// Common for many
Private Function StripEndNull(ByVal Value As String) As String
    StripEndNull = Left(Value, InStr(1, Value, Chr(0)) - 1)
End Function


Private Sub UserControl_Initialize()
    l_IsWinNT = IsWinNT
End Sub

Private Sub UserControl_Resize()
    UserControl.Width = lblTitle.Width
    UserControl.Height = lblTitle.Height
    lblTitle.Move 0, 0
End Sub

