VERSION 5.00
Begin VB.UserControl FileFunctions 
   ClientHeight    =   480
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   InvisibleAtRuntime=   -1  'True
   ScaleHeight     =   480
   ScaleWidth      =   4800
   ToolboxBitmap   =   "FileFunctions.ctx":0000
   Windowless      =   -1  'True
   Begin VB.Label lblTitle 
      Caption         =   "File Functions"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      Height          =   390
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   2190
   End
End
Attribute VB_Name = "FileFunctions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'///////////////////////////////////////////
'// File Functions doesn't have an interface
'// In reality it just acts as a class module

' Consts
'    Private Const FO_MOVE = &H1
'    Private Const FO_COPY = &H2
'    Private Const FO_DELETE = &H3
'    Private Const FO_RENAME = &H4

'    Private Const FOF_MULTIDESTFILES = &H1
'    Private Const FOF_CONFIRMMOUSE = &H2
'    Private Const FOF_SILENT = &H4
'    Private Const FOF_RENAMEONCOLLISION = &H8
'    Private Const FOF_NOCONFIRMATION = &H10
'    Private Const FOF_WANTMAPPINGHANDLE = &H20
'    Private Const FOF_CREATEPROGRESSDLG = &H0
'    Private Const FOF_ALLOWUNDO = &H40
'    Private Const FOF_FILESONLY = &H80
'    Private Const FOF_SIMPLEPROGRESS = &H100
'    Private Const FOF_NOCONFIRMMKDIR = &H200

    Private Const SHARD_PATH = &H2&

' Enums
    Public Enum eFileOps
        FO_MOVE = &H1
        FO_COPY = &H2
        FO_DELETE = &H3
        FO_RENAME = &H4
    End Enum

    Public Enum eFileOpsFlags
        FOF_NOFLAGS = 0
        FOF_MULTIDESTFILES = &H1
        FOF_CONFIRMMOUSE = &H2
        FOF_SILENT = &H4
        FOF_RENAMEONCOLLISION = &H8
        FOF_NOCONFIRMATION = &H10
        FOF_WANTMAPPINGHANDLE = &H20
        FOF_CREATEPROGRESSDLG = &H0
        FOF_ALLOWUNDO = &H40
        FOF_FILESONLY = &H80
        FOF_SIMPLEPROGRESS = &H100
        FOF_NOCONFIRMMKDIR = &H200
    End Enum

' Types
    Public Type SHFILEOPSTRUCT
        hWnd    As Long
        wFunc   As Long
        pFrom   As String
        pTo     As String
        fFlags  As Long
        fAnyOperationsAborted   As Long
        hNameMappings           As Long
        lpszProgressTitle       As String
     End Type

' APIs
    Private Declare Function SHAddToRecentDocs Lib "shell32" (ByVal dwFlags As Long, ByVal dwData As String) As Long
    Private Declare Function SHFileOperation Lib "shell32" Alias "SHFileOperationA" (lpFileOp As SHFILEOPSTRUCT) As Long

Option Explicit

Public Function RenameFile(ByVal FromName As String, ByVal ToName As String, ByVal hWnd As Long, Optional ByVal Title As String, Optional ByVal fFlags As eFileOpsFlags) As Long
    RenameFile = FileUtils(FO_RENAME, FromName, ToName, hWnd, Title, fFlags)
End Function

Public Function DeleteFile(ByVal FileName As String, ByVal hWnd As Long, Optional ByVal Title As String, Optional ByVal fFlags As eFileOpsFlags) As Long
    DeleteFile = FileUtils(FO_DELETE, FileName, "", hWnd, Title, fFlags)
End Function

Public Function MoveFile(ByVal Source As String, ByVal Destination As String, ByVal hWnd As Long, Optional ByVal Title As String, Optional ByVal fFlags As eFileOpsFlags) As Long
    MoveFile = FileUtils(FO_MOVE, Source, Destination, hWnd, Title, fFlags)
End Function

Public Function CopyFile(ByVal Source As String, ByVal Destination As String, ByVal hWnd As Long, Optional ByVal Title As String, Optional ByVal fFlags As eFileOpsFlags) As Long
    CopyFile = FileUtils(FO_COPY, Source, Destination, hWnd, Title, fFlags)
End Function

Private Function FileUtils(ByVal Func As eFileOps, ByVal Source As String, ByVal Destination As String, ByVal hWnd As Long, Optional ByVal sTitle As String = "", Optional ByVal fFlags As eFileOpsFlags = FOF_NOFLAGS)
    Dim FileOP As SHFILEOPSTRUCT
    Dim fPassCheck As Boolean

' OK, quick checks
    fPassCheck = False
    If Source <> "" Then
        If Func <> FO_DELETE Then
            If Destination <> "" Then
                fPassCheck = True
            End If
        Else
            fPassCheck = True
        End If
    End If
        
    If fPassCheck Then
    ' Need terminating null
        Source = Source & Chr(0)
        If Destination <> "" Then
            Destination = Destination & Chr(0)
        End If
    ' Setup title if none exists
        If sTitle = "" Then
            If Func = FO_COPY Then
                sTitle = "Copying..."
            ElseIf Func = FO_DELETE Then
                sTitle = "Deleting..."
            ElseIf Func = FO_MOVE Then
                sTitle = "Moving..."
            ElseIf Func = FO_RENAME Then
                sTitle = "Renaming..."
            End If
        End If
    ' OK, now setup the structure
        With FileOP
            .wFunc = Func
            .fFlags = fFlags
            .hWnd = hWnd
            .lpszProgressTitle = sTitle
            .pFrom = Source
            If Func <> FO_DELETE Then
                .pTo = Destination
            End If
        End With
        
        FileUtils = SHFileOperation(FileOP)
    End If
End Function

Public Function AddFileToRecentDocs(ByVal FileName As String) As Long
    If FileName <> "" Then
        If Dir(FileName) <> "" Then
            AddFileToRecentDocs = SHAddToRecentDocs(SHARD_PATH, FileName)
        End If
    End If
End Function




Private Sub UserControl_Resize()
    UserControl.Width = lblTitle.Width
    UserControl.Height = lblTitle.Height
    lblTitle.Move 0, 0
End Sub
